"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from codat_lending.models.shared import (
    bankingaccount as shared_bankingaccount,
    bankingtransactions as shared_bankingtransactions,
    path as shared_path,
)
from codat_lending.types import BaseModel
from codat_lending.utils import (
    FieldMetadata,
    PathParamMetadata,
    QueryParamMetadata,
    RequestMetadata,
)
import pydantic
from typing import Any, Optional, TypedDict, Union
from typing_extensions import Annotated, NotRequired


UploadBankStatementDataRequestBodyTypedDict = Union[
    shared_bankingtransactions.BankingTransactionsTypedDict,
    shared_bankingaccount.BankingAccountTypedDict,
    Any,
]


UploadBankStatementDataRequestBody = Union[
    shared_bankingtransactions.BankingTransactions,
    shared_bankingaccount.BankingAccount,
    Any,
]


class UploadBankStatementDataRequestTypedDict(TypedDict):
    request_body: UploadBankStatementDataRequestBodyTypedDict
    company_id: str
    r"""Unique identifier for a company."""
    connection_id: str
    r"""Unique identifier for a connection."""
    dataset_id: str
    r"""Unique identifier for the dataset that completed its sync."""
    path: NotRequired[shared_path.Path]
    r"""The endpoint path of the third-party banking service that the request body originates from. Only required if the source is not `codat`."""


class UploadBankStatementDataRequest(BaseModel):
    request_body: Annotated[
        UploadBankStatementDataRequestBody,
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ]

    company_id: Annotated[
        str,
        pydantic.Field(alias="companyId"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""Unique identifier for a company."""

    connection_id: Annotated[
        str,
        pydantic.Field(alias="connectionId"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""Unique identifier for a connection."""

    dataset_id: Annotated[
        str,
        pydantic.Field(alias="datasetId"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""Unique identifier for the dataset that completed its sync."""

    path: Annotated[
        Optional[shared_path.Path],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""The endpoint path of the third-party banking service that the request body originates from. Only required if the source is not `codat`."""
