"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .productvariant import ProductVariant, ProductVariantTypedDict
from .supplementaldata import SupplementalData, SupplementalDataTypedDict
from codat_lending.types import BaseModel
import pydantic
from typing import List, Optional, TypedDict
from typing_extensions import Annotated, NotRequired


class CommerceProductTypedDict(TypedDict):
    r"""A Product is an item in the company's inventory, and includes information about the price and quantity of all products, and variants thereof, available for sale.

    Explore our [data coverage](https://knowledge.codat.io/supported-features/commerce?view=tab-by-data-type&dataType=commerce-products) for this data type.

    """

    id: str
    r"""A unique, persistent identifier for this record"""
    categorization: NotRequired[str]
    r"""Retail category that the product is assigned to e.g. `Hardware`."""
    description: NotRequired[str]
    r"""Description of the product recorded in the commerce or point of sale platform."""
    is_gift_card: NotRequired[bool]
    r"""Whether the product represents a gift card or voucher that
    can be redeemed in the commerce or POS platform.

    """
    name: NotRequired[str]
    r"""Name of the product in the commerce or POS system"""
    supplemental_data: NotRequired[SupplementalDataTypedDict]
    r"""Supplemental data is additional data you can include in our standard data types.

    It is referenced as a configured dynamic key value pair that is unique to the accounting software. [Learn more](https://docs.codat.io/using-the-api/supplemental-data/overview) about supplemental data.
    """
    variants: NotRequired[List[ProductVariantTypedDict]]


class CommerceProduct(BaseModel):
    r"""A Product is an item in the company's inventory, and includes information about the price and quantity of all products, and variants thereof, available for sale.

    Explore our [data coverage](https://knowledge.codat.io/supported-features/commerce?view=tab-by-data-type&dataType=commerce-products) for this data type.

    """

    id: str
    r"""A unique, persistent identifier for this record"""

    categorization: Optional[str] = None
    r"""Retail category that the product is assigned to e.g. `Hardware`."""

    description: Optional[str] = None
    r"""Description of the product recorded in the commerce or point of sale platform."""

    is_gift_card: Annotated[Optional[bool], pydantic.Field(alias="isGiftCard")] = None
    r"""Whether the product represents a gift card or voucher that
    can be redeemed in the commerce or POS platform.

    """

    name: Optional[str] = None
    r"""Name of the product in the commerce or POS system"""

    supplemental_data: Annotated[
        Optional[SupplementalData], pydantic.Field(alias="supplementalData")
    ] = None
    r"""Supplemental data is additional data you can include in our standard data types.

    It is referenced as a configured dynamic key value pair that is unique to the accounting software. [Learn more](https://docs.codat.io/using-the-api/supplemental-data/overview) about supplemental data.
    """

    variants: Optional[List[ProductVariant]] = None
