"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from codat_lending.types import BaseModel
import pydantic
from typing import Optional, TypedDict
from typing_extensions import Annotated, NotRequired


class RecordRefTypedDict(TypedDict):
    r"""Links the current record to the underlying record or data type that created it.

    For example, if a journal entry is generated based on an invoice, this property allows you to connect the journal entry to the underlying invoice in our data model.
    """

    data_type: NotRequired[str]
    r"""Allowed name of the 'dataType'."""
    id: NotRequired[str]
    r"""'id' of the underlying record or data type."""


class RecordRef(BaseModel):
    r"""Links the current record to the underlying record or data type that created it.

    For example, if a journal entry is generated based on an invoice, this property allows you to connect the journal entry to the underlying invoice in our data model.
    """

    data_type: Annotated[Optional[str], pydantic.Field(alias="dataType")] = None
    r"""Allowed name of the 'dataType'."""

    id: Optional[str] = None
    r"""'id' of the underlying record or data type."""
